package me.wazup.hideandseek.disguise;

import me.wazup.hideandseek.xseries.XMaterial;
import org.bukkit.Material;
import me.libraryaddict.disguise.disguisetypes.MobDisguise;
import me.libraryaddict.disguise.disguisetypes.DisguiseType;
import me.libraryaddict.disguise.disguisetypes.Disguise;
import org.bukkit.entity.Entity;
import me.libraryaddict.disguise.DisguiseAPI;
import org.bukkit.inventory.ItemStack;
import org.bukkit.entity.Player;
import me.libraryaddict.disguise.disguisetypes.MiscDisguise;
import java.lang.reflect.Constructor;

public class LibsDisguises extends DisguiseManager
{
    Constructor<MiscDisguise> newConstructor;
    
    @Override
    public void disguise(final Player player, final ItemStack itemStack) {
        DisguiseAPI.disguiseToAll((Entity)player, (Disguise)this.getDisguise(itemStack));
    }
    
    @Override
    public void disguise(final Player player, final String s) {
        DisguiseAPI.disguiseToAll((Entity)player, (Disguise)new MobDisguise(DisguiseType.valueOf(s)));
    }
    
    @Override
    public void undisguise(final Player player) {
        DisguiseAPI.undisguiseToAll((Entity)player);
    }
    
    @Override
    public boolean valid() {
        try {
            this.newConstructor = MiscDisguise.class.getConstructor(DisguiseType.class, Material.class, Integer.TYPE);
        }
        catch (final Exception ex) {}
        try {
            this.getDisguise(XMaterial.GRASS_BLOCK.parseItem());
            return true;
        }
        catch (final Exception ex2) {
            ex2.printStackTrace();
            return false;
        }
    }
    
    @Override
    public String getName() {
        return "Libs Disguise";
    }
    
    private MiscDisguise getDisguise(final ItemStack itemStack) {
        if (this.newConstructor != null) {
            return new MiscDisguise(DisguiseType.FALLING_BLOCK, itemStack);
        }
        return new MiscDisguise(DisguiseType.FALLING_BLOCK, itemStack.getType().getId(), (int)itemStack.getDurability());
    }
}
